{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 08 May 2001.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 08 May 2001

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:


-----------------------------------------------------------------------------}
{
  Rus:
      .
      .
       (join to game)  .
       (  ).
    - DirectPlay SDK    DelphiX.

  Eng:
  Calculations are made ONLY by a client part.
  The server program create one client.
  All launched clients should join to game.
  The search of the server is possible to do automatically (empty name of the server).
  In more detail - DirectPlay SDK or examples to DelphiX.
}
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VideoCalculator, ComCtrls, ExtCtrls, StdCtrls, DIB, DXPlay,SelectProvForm,
  General;

type

  TForm1 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    DXDIB1: TDXDIB;
    DXPaintBox1: TDXPaintBox;
    CalculatorsList: TMemo;
    DXPlay1: TDXPlay;
    procedure DXPlay1AddPlayer(Sender: TObject; Player: TDXPlayPlayer);
    procedure DXPlay1DeletePlayer(Sender: TObject; Player: TDXPlayPlayer);
    procedure DXPlay1Message(Sender: TObject; From: TDXPlayPlayer;
      Data: Pointer; DataSize: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    Calculator:TVideoCalculator;
    Server:TDXPlayPlayer;
    procedure OnCalculationTerminate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function Demo1 (const x,y,val:double):double;
begin
  result:=val+3.00001+10*sqr(sqr(0.5-y)+sqr(0.5-x))+sin(x*val*Pi)+cos(y*val*Pi)+sin(val*Pi);
end;

{ TForm1 }

procedure TForm1.OnCalculationTerminate(Sender: TObject);
var buflength:integer;
    dataptr:pointer;
    destptr:pointer;
    i:integer;
begin
   IsCalculating:=false;
   ResponseHeader.command:=pcResults;
   ResponseHeader.y0:=Calculator.a;
   ResponseHeader.y1:=Calculator.b;
   ResponseHeader.width:=DXDIB1.DIB.Width;
   ResponseHeader.height:=DXDIB1.DIB.Height;
   Move(ResponseHeader,ResponseData[0],SizeOf(TDataRes));
   buflength:=Length(ResponseData);
   if DXDIB1.DIB.WidthBytes*(Calculator.b-Calculator.a)>buflength then
     SetLength(ResponseData,DXDIB1.DIB.WidthBytes*(Calculator.b-Calculator.a+1)+SizeOf(TDataRes));
   destptr:=@(ResponseData[SizeOf(TDataRes)]);
   //DXDIB1.DIB.Canvas.Lock;
   try
   for i:=ResponseHeader.y0 to ResponseHeader.y1 do
   begin
    dataptr:=DXDIB1.DIB.ScanLine[i];
    Move(dataptr^,destptr^,DXDIB1.DIB.WidthBytes);
    destptr:=@(PByteArray(destptr)[DXDIB1.DIB.WidthBytes]);
   end;
   except
     Close;
   end;  
  // DXDIB1.DIB.Canvas.UnLock;
   DXPlay1.SendMessage(Server.ID,ResponseData,DXDIB1.DIB.WidthBytes*(Calculator.b-Calculator.a+1)+SizeOf(TDataRes));
   DXPaintBox1.DIB.Canvas.Draw(0,0,DXDIB1.DIB);
   DXPaintBox1.Repaint;
end;

procedure TForm1.DXPlay1AddPlayer(Sender: TObject; Player: TDXPlayPlayer);
begin
  CalculatorsList.Lines.Add(Player.DisplayName);
end;

procedure TForm1.DXPlay1DeletePlayer(Sender: TObject;
  Player: TDXPlayPlayer);
begin
  CalculatorsList.Lines.Delete(CalculatorsList.Lines.IndexOf(Player.DisplayName));
end;

procedure TForm1.DXPlay1Message(Sender: TObject; From: TDXPlayPlayer;
  Data: Pointer; DataSize: Integer);
begin
//firstly - TDataRes, after-data as bytes
IsOccupied:=true;
if TDataRes(Data^).command=pcCalculate then
 begin
   IsCalculating:=true;
   Server:=From;
   if DXDIB1.DIB=nil then
       DXDIB1.DIB:=TDIB.Create;
   DXDIB1.DIB.SetSize(TDataRes(Data^).width,TDataRes(Data^).height,32);
   Calculator:=TVideoCalculator.Create(DXDIB1.DIB);
   Calculator.OnTerminate:=OnCalculationTerminate;
   Calculator.Run(TDataRes(Data^).y0,TDataRes(Data^).y1,TDataRes(Data^).Iters,Demo1);
 end else
if TDataRes(Data^).command=pcStop then
 begin
   if IsCalculating then Calculator.Terminate;
   ShowMessage('I am stopping...');
 end else
if TDataRes(Data^).command=pcClose then
 begin
   if IsCalculating then Calculator.Terminate;
   Close;
 end;
IsOccupied:=false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DXPlay1.Close;
end;

end.
