{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 08 May 2001.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 08 May 2001

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:


-----------------------------------------------------------------------------}
{
  Rus:
      .
      .
       (join to game)  .
       (  ).
    - DirectPlay SDK    DelphiX.

  Eng:
  Calculations are made ONLY by a client part.
  The server program create one client.
  All launched clients should join to game.
  The search of the server is possible to do automatically (empty name of the server).
  In more detail - DirectPlay SDK or examples to DelphiX.
}
unit Main;

interface

uses
  Windows,DirectX, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VideoCalculator, ComCtrls, ExtCtrls, StdCtrls, DIB, DXPlay,SelectProvForm,
  General,Math, Menus,clipbrd;

type

  TForm1 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Button1: TButton;
    Timer1: TTimer;
    DXDIB1: TDXDIB;
    DXPaintBox1: TDXPaintBox;
    Button2: TButton;
    TrackBar1: TTrackBar;
    DXPlay1: TDXPlay;
    CalculatorsList: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    N1: TMenuItem;
    Clear1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DXPlay1AddPlayer(Sender: TObject; Player: TDXPlayPlayer);
    procedure DXPlay1DeletePlayer(Sender: TObject; Player: TDXPlayPlayer);
    procedure DXPlay1Message(Sender: TObject; From: TDXPlayPlayer;
      Data: Pointer; DataSize: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TrackBar1Change(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    curr_y:integer;
    IsStopped:boolean;
    Calculator:TVideoCalculator;
    Server:TDXPlayPlayer;
    CurrentClient:TDXPlayPlayer;
    procedure OnCalculationTerminate(Sender: TObject);
    procedure SendNextDataToClient(const ID:integer);
    procedure SendCommand(const cmd:TPlayCommand);    
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
function Demo1 (const x,y,val:double):double;
begin
  result:=val+3.00001+10*sqr(sqr(0.5-y)+sqr(0.5-x))+sin(x*val*Pi)+cos(y*val*Pi)+sin(val*Pi);
end;

{ TForm1 }

procedure TForm1.OnCalculationTerminate(Sender: TObject);
var buflength:integer;
    dataptr:pointer;
    destptr:pointer;
    i:integer;
begin
   IsCalculating:=false;
   ResponseHeader.command:=pcResults;
   ResponseHeader.y0:=Calculator.a;
   ResponseHeader.y1:=Calculator.b;
   Move(ResponseHeader,ResponseData[0],SizeOf(TDataRes));
   buflength:=Length(ResponseData);
   if DXDIB1.DIB.WidthBytes*(Calculator.b-Calculator.a)>buflength then
     SetLength(ResponseData,DXDIB1.DIB.WidthBytes*(Calculator.b-Calculator.a+1)+SizeOf(TDataRes));
   destptr:=@(ResponseData[SizeOf(TDataRes)]);
   //DXDIB1.DIB.Canvas.Lock;
   // move result data to dest array
   try
     for i:=Calculator.a to Calculator.b do
     begin
      dataptr:=DXDIB1.DIB.ScanLine[i];
      Move(dataptr^,destptr^,DXDIB1.DIB.WidthBytes);
      destptr:=@(PByteArray(destptr)[DXDIB1.DIB.WidthBytes]);
     end;
   except
    Close;
   end;
  // DXDIB1.DIB.Canvas.UnLock;
  // send dest array to server
  DXPlay1.SendMessage(Server.ID,ResponseData,DXDIB1.DIB.WidthBytes*(Calculator.b-Calculator.a+1)+SizeOf(TDataRes));
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
 IsEndSession:=false;
 IsStopped:=false;
 try
 DXPaintBox1.DIB.SetSize(DXPaintBox1.Width,DXPaintBox1.Height,32);
 DXDIB1.DIB.SetSize(DXPaintBox1.Width,DXPaintBox1.Height,32);
 for i:=0 to DXPlay1.Players.Count-1 do
  SendNextDataToClient(DXPlay1.Players.Players[i].ID);
 except
   Close;
 end;
 Button1.Enabled:=false;
 Button2.Enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var dt:TDataRes;
begin
 IsStopped:=true;
 Timer1.Enabled:=false;
 dt.command:=pcStop;
 try
   DXPlay1.SendMessage(DPID_ALLPLAYERS,@dt,SizeOf(TDataRes));
   DXPlay1.SendMessage(DPID_SERVERPLAYER,@dt,SizeOf(TDataRes));
 except
  Close;
 end;
 curr_y:=0;
 Button2.Enabled:=false;
 Button1.Enabled:=true;
end;

procedure TForm1.DXPlay1AddPlayer(Sender: TObject; Player: TDXPlayPlayer);
begin
  CalculatorsList.Lines.Add(Player.DisplayName);
end;

procedure TForm1.DXPlay1DeletePlayer(Sender: TObject;
  Player: TDXPlayPlayer);
begin
  CalculatorsList.Lines.Delete(CalculatorsList.Lines.IndexOf(Player.DisplayName));
end;

procedure TForm1.DXPlay1Message(Sender: TObject; From: TDXPlayPlayer;
  Data: Pointer; DataSize: Integer);
var i:integer;
    pixels:TData;
    dest:pointer;
begin
//firstly - TDataRes, after-data as bytes
IsOccupied:=true;
if TDataRes(Data^).command=pcResults then
 begin
  CurrentClient:=From;
  if (curr_y<DXDIB1.DIB.Height) and not IsStopped and not IsEndSession then
     SendNextDataToClient(From.ID)
   else
   begin
     try
       IsEndSession:=true;
       curr_y:=0;
       DXPaintBox1.DIB.Assign(DXDIB1.DIB);
     except
       Close;
     end;
     Button2.Enabled:=false;
     Button1.Enabled:=true;
   end;
  pixels:=@(PByteArray(Data)[SizeOf(TDataRes)]);
  for i:=TDataRes(Data^).y0 to TDataRes(Data^).y1 do
    begin
     dest:=DXDIB1.DIB.ScanLine[i];
     Move(pixels^,dest^,DXDIB1.DIB.widthbytes);
     pixels:=@(PByteArray(pixels)[DXDIB1.DIB.widthbytes]);
    end;
   {for i:=TDataRes(Data^).y0 to TDataRes(Data^).y1 do
    for j:=0 to DXDIB1.DIB.Width-1 do
     begin
     DXDIB1.DIB.Pixels[j,i]:=TColor(pixels^);
     Inc(pixels);
     end;}
    try
      DXPaintBox1.Canvas.Draw(0,0,DXDIB1.DIB);
    except
      Close;
    end;  
 end else
if TDataRes(Data^).command=pcCalculate then
 begin
   IsCalculating:=true;
   Server:=From;
   if DXDIB1.DIB=nil then
       DXDIB1.DIB:=TDIB.Create;
   DXDIB1.DIB.SetSize(TDataRes(Data^).width,TDataRes(Data^).height,32);
   Calculator:=TVideoCalculator.Create(DXDIB1.DIB);
   Calculator.OnTerminate:=OnCalculationTerminate;
   Calculator.Run(TDataRes(Data^).y0,TDataRes(Data^).y1,TDataRes(Data^).Iters,Demo1);
 end else
if TDataRes(Data^).command=pcStop then
 begin
   if IsCalculating then Calculator.Terminate;
   ShowMessage('I am stopping...');
 end;
IsOccupied:=false;
end;

procedure TForm1.SendNextDataToClient(const ID: integer);
var dt:TDataRes;
begin
 Timer1.Enabled:=false;
 if curr_y>=DXDIB1.DIB.Height-1 then exit;
 dt.command:=pcCalculate;
 dt.y0:=curr_y;
 dt.y1:=curr_y+min(15,(DXDIB1.DIB.Height-1)-curr_y);
 Inc(curr_y,15);
 dt.width:=DXDIB1.DIB.Width;
 dt.height:=DXDIB1.DIB.Height;
 try
  dt.Iters:=StrToInt(Edit1.Text);
 except
  Edit1.Text:='500';
  dt.Iters:=500;
 end;
 DXPlay1.SendMessage(ID,@dt,SizeOf(TDataRes));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SendCommand(pcClose); 
 DXPlay1.Close;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 Edit1.Text:=IntToStr(TrackBar1.Position);
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
  Clipboard.Assign(DXDIB1.DIB);
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
  with DXPaintBox1.DIB.Canvas do
  begin
    brush.color:=clBlack;
    pen.color:=clBlack;
    Rectangle(0,0,DXPaintBox1.DIB.Width,DXPaintBox1.DIB.Height);
  end;
  DXPaintBox1.Refresh;
end;

procedure TForm1.SendCommand(const cmd: TPlayCommand);
var dt:TDataRes;
begin
 dt.command:=cmd;
 try
   DXPlay1.SendMessage(DPID_ALLPLAYERS,@dt,SizeOf(TDataRes));
 except
  Close;
 end;
end;

end.
