unit VideoCalculator;

interface

uses
  Windows,Classes,Graphics,Dialogs,SysUtils,DIB,General;

type
  //x,y in [0..1] prev=previous part
  TFunction=function (const x ,y ,prev :double):double;
  TVideoCalculator = class(TThread)
  private
    { Private declarations }
    func: TFunction;
  protected
    procedure Execute; override;
  public
    FBitmap:TDIB;
    a, b, Iterations: integer;
    y:integer;
    constructor Create(Bitmap:TDIB);
    //  a in [0..b-1]; b in [a+1..Bitmap.Height-1]
    procedure Run(const a,b,Iters:integer;func:TFunction);
  end;

implementation

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TVideoCalculator.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TVideoCalculator }

constructor TVideoCalculator.Create(Bitmap: TDIB);
begin
  inherited Create(true);
  FBitmap:=Bitmap;
end;

procedure TVideoCalculator.Execute;
var i,j,n:integer;
    value,rx,ry:double;
    pixels:TData;
   //default: Bitmap.PixelFormat==pf32bit;
begin
 for i:=a to b do
 begin
   y:=i;
   ry:=i/FBitmap.Height;
   pixels:=FBitmap.ScanLine[i];
   for j:=0 to FBitmap.Width-1 do
    begin
      n:=0;
      value:=sin(i)+cos(j);
      rx:=j/FBitmap.Width;
      while (abs(value)<Iterations) and not Terminated do
        begin
        inc(n);
        value:=func(rx,ry,value);
        end;
      //FBitmap.Pixels[j,i]:=rgb(n,255-n,255-n);//Cardinal((@value)^);//rgb(100,n,n mod 256);
       pixels^:=rgb(n,255-n,255-n);
       inc(pixels);
      if terminated then exit;
    end;
 end;
end;

procedure TVideoCalculator.Run(const a, b, Iters: integer; func: TFunction);
begin
 Self.a:=a;
 Self.b:=b;
 Self.func:=func;
 Iterations:=Iters;
 Resume;
end;

end.
